ca65 V2.18 - Git cab4910
Main file   : decompressor.s
Current file: decompressor.s

000000r 1               ;  Copyright (c) 2019, Vintage Computing Carinthia
000000r 1               ;  Author: WOZ    -    http://www.pin4.at/    -    woz <at> pin4 <dot> at
000000r 1               ;  All rights reserved.
000000r 1               ;
000000r 1               ;  Petscii decompressor, unpacks directly to the screen
000000r 1               ;
000000r 1               ;  Redistribution and use in source and binary forms, with or without
000000r 1               ;  modification, are permitted provided that the following conditions are met:
000000r 1               ;      * Redistributions of source code must retain the above copyright
000000r 1               ;        notice, this list of conditions and the following disclaimer.
000000r 1               ;      * Redistributions in binary form must reproduce the above copyright
000000r 1               ;        notice, this list of conditions and the following disclaimer in the
000000r 1               ;        documentation and/or other materials provided with the distribution.
000000r 1               ;      * Neither the name of the author(s) nor the
000000r 1               ;        names of its contributors may be used to endorse or promote products
000000r 1               ;        derived from this software without specific prior written permission.
000000r 1               ;      * Commercial use prohibited without permission of the author(s).
000000r 1               ;
000000r 1               ;  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
000000r 1               ;  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
000000r 1               ;  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
000000r 1               ;  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR(S) BE LIABLE FOR ANY
000000r 1               ;  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
000000r 1               ;  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
000000r 1               ;  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
000000r 1               ;  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
000000r 1               ;  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
000000r 1               ;  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
000000r 1               ;
000000r 1               
000000r 1               ;===============================================
000000r 1               ; BUILD WITH
000000r 1               ; cl65 -o decompressor.prg -t c64 -C c64-asm.cfg -l decompressor.asm  decompressor.s
000000r 1               ;===============================================
000000r 1               
000000r 1               ;screen addresses (you may change sptr+1/sptr+2 directly for other screen locations)
000000r 1               screen=$0400
000000r 1               colour=$D800
000000r 1               
000000r 1               ;zeropage pointer
000000r 1               inv = $f9
000000r 1               col = $fa
000000r 1               dbl1a = $fb
000000r 1               dbl1b = $fc
000000r 1               dbl2a = $fd
000000r 1               dbl2b = $fe
000000r 1               cnt = $ff
000000r 1               
000000r 1               ;===============================================
000000r 1               ;BASIC start header
000000r 1               
000000r 1               .org $0801
000801  1               
000801  1  0B 08 20 03  .byte $0B, $08, $20, $03, $9E, $32, $30, $36, $31, $00, $00, $00   ; SYS 2061
000805  1  9E 32 30 36  
000809  1  31 00 00 00  
00080D  1               
00080D  1               ;===============================================
00080D  1               ;ASM start
00080D  1               
00080D  1               ;-----------------------------------------------
00080D  1               ; set some variables we will neeed
00080D  1               _decompress:
00080D  1  A9 00          lda #$00
00080F  1  85 F9          sta inv        ; clear inverse flag
000811  1  85 FA          sta col        ; clear color
000813  1  85 FF          sta cnt        ; clear counter
000815  1  AD BD 08       lda _example
000818  1  8D 20 D0       sta $D020
00081B  1  AD BE 08       lda _example+1
00081E  1  8D 21 D0       sta $D021
000821  1  AD C2 08       lda _example+5
000824  1  F0 1A          beq mainloop    ; have no double definitions
000826  1               
000826  1               ;-----------------------------------------------
000826  1               ; set double data definitions
000826  1  85 FB          sta dbl1a
000828  1  AD C3 08       lda _example+6
00082B  1  85 FC          sta dbl1b
00082D  1  AD C4 08       lda _example+7
000830  1  85 FD          sta dbl2a
000832  1  AD C5 08       lda _example+8
000835  1  85 FE          sta dbl2b
000837  1                 ; for now we assume there is not carry to the upper byte involved
000837  1  EE 41 08       inc mainloop+1
00083A  1  EE 41 08       inc mainloop+1
00083D  1  EE 41 08       inc mainloop+1
000840  1               
000840  1               ;-----------------------------------------------
000840  1               ; here we run through the data until we reach 0x00
000840  1               mainloop:
000840  1  AD C3 08       lda _example+6
000843  1  F0 73          beq exit
000845  1  EE 41 08       inc mainloop+1
000848  1  D0 03          bne next0
00084A  1  EE 42 08       inc mainloop+2
00084D  1               next0:
00084D  1  C9 60          cmp #$60
00084F  1  B0 05          bcs unroll
000851  1                 ; char < $60, set repetition for next data
000851  1  85 FF          sta cnt
000853  1  4C 40 08       jmp mainloop
000856  1               
000856  1               ; we unroll here runlength encoded data
000856  1               unroll:
000856  1  A8             tay
000857  1  20 64 08       jsr usebyte
00085A  1                 ; continue in stream cnt is zero
00085A  1  A5 FF          lda cnt
00085C  1  F0 E2          beq mainloop
00085E  1                 ; otherwise decrement cnt, get back char and do it again
00085E  1  C6 FF          dec cnt
000860  1  98             tya
000861  1  4C 56 08       jmp unroll
000864  1               
000864  1               ;-----------------------------------------------
000864  1               ; we decode a single data field
000864  1               usebyte:
000864  1  C9 70          cmp #$70
000866  1  F0 15          beq invon
000868  1  C9 71          cmp #$71
00086A  1  F0 16          beq invoff
00086C  1  C9 78          cmp #$78
00086E  1  F0 17          beq dbl1
000870  1  C9 79          cmp #$79
000872  1  F0 1D          beq dbl2
000874  1  C9 80          cmp #$80
000876  1  B0 23          bcs write  ; >=$80, poke character
000878  1               setcol:
000878  1  29 0F          and #$0F   ; what remains here must be colour
00087A  1  85 FA          sta col
00087C  1  60             rts
00087D  1               invon:
00087D  1  A9 80          lda #$80   ; set inversion
00087F  1  85 F9          sta inv
000881  1  60             rts
000882  1               invoff:
000882  1  A9 00          lda #$00   ; set normal
000884  1  85 F9          sta inv
000886  1  60             rts
000887  1               dbl1:
000887  1  A5 FB          lda dbl1a
000889  1  20 64 08       jsr usebyte
00088C  1  A5 FC          lda dbl1b
00088E  1  4C 64 08       jmp usebyte
000891  1               dbl2:
000891  1  A5 FD          lda dbl2a
000893  1  20 64 08       jsr usebyte
000896  1  A5 FE          lda dbl2b
000898  1  4C 64 08       jmp usebyte
00089B  1               write:
00089B  1  29 7F          and #$7F  ; character or inv. character
00089D  1  05 F9          ora inv
00089F  1               sptr:
00089F  1  8D 00 04       sta screen
0008A2  1  EE A0 08       inc sptr+1
0008A5  1  D0 03          bne next1
0008A7  1  EE A1 08       inc sptr+2
0008AA  1               next1:
0008AA  1  A5 FA          lda col
0008AC  1               cptr:
0008AC  1  8D 00 D8       sta colour
0008AF  1  EE AD 08       inc cptr+1
0008B2  1  D0 03          bne next2
0008B4  1  EE AE 08       inc cptr+2
0008B7  1               next2:
0008B7  1  60             rts
0008B8  1               
0008B8  1               ;-----------------------------------------------
0008B8  1               ; finally, we are done (we wait for a keypress)
0008B8  1               exit:
0008B8  1  A5 C6          lda $c6
0008BA  1  F0 FC          beq exit
0008BC  1  60             rts
0008BD  1               
0008BD  1               ;===============================================
0008BD  1               ;example picture 1, author LgK
0008BD  1               ; runs in 92364 cycles  -->  ~100ms
0008BD  1               _example:
0008BD  1               ; compressed petscii sequence data
0008BD  1  00 00 28 19  .byte $00, $00, $28, $19, $00, $00, $5f, $a0, $5f, $a0, $16, $a0, $67, $c9, $d5, $c9, $a0, $d5, $c3, $c9, $a0, $d5, $c3, $c9, $1c, $a0, $c2, $ca, $db, $a0, $dd, $02
0008C1  1  00 00 5F A0  
0008C5  1  5F A0 16 A0  
0008DD  1  A0 DD 1E A0  .byte $a0, $dd, $1e, $a0, $c2, $a0, $dd, $a0, $dd, $02, $a0, $dd, $1e, $a0, $ca, $c0, $fd, $a0, $ca, $c3, $cb, $a0, $ca, $c3, $cb, $5f, $a0, $08, $a0, $c9, $d5, $25
0008E1  1  C2 A0 DD A0  
0008E5  1  DD 02 A0 DD  
0008FD  1  A0 C2 DD 25  .byte $a0, $c2, $dd, $25, $a0, $ca, $fd, $a0, $89, $a0, $8e, $a0, $94, $a0, $81, $a0, $87, $a0, $85, $1a, $a0, $d5, $cb, $25, $a0, $dd, $26, $a0, $ca, $cb, $a0, $8f
000901  1  A0 CA FD A0  
000905  1  89 A0 8E A0  
00091D  1  A0 8D A0 90  .byte $a0, $8d, $a0, $90, $a0, $95, $a0, $94, $a0, $89, $a0, $8e, $a0, $87, $16, $a0, $d5, $cb, $25, $a0, $dd, $26, $a0, $ca, $cb, $a0, $81, $a0, $92, $a0, $89, $a0
000921  1  A0 95 A0 94  
000925  1  A0 89 A0 8E  
00093D  1  8E A0 94 A0  .byte $8e, $a0, $94, $a0, $88, $a0, $89, $a0, $81, $5f, $a0, $5f, $a0, $10, $a0, $00
000941  1  88 A0 89 A0  
000945  1  81 5F A0 5F  
00094D  1               
00094D  1               ; see http://6502org.wikidot.com/software-incdec for some coding techniques used
00094D  1               
