ca65 V2.18 - Git cab4910
Main file   : seqreader.s
Current file: seqreader.s

000000r 1               ;  Copyright (c) 2019, Vintage Computing Carinthia
000000r 1               ;  Author: WOZ    -    http://www.pin4.at/    -    woz <at> pin4 <dot> at
000000r 1               ;  All rights reserved.
000000r 1               ;
000000r 1               ;  Petscii SEQ reader, unpacks directly to the screen
000000r 1               ;
000000r 1               ;  Redistribution and use in source and binary forms, with or without
000000r 1               ;  modification, are permitted provided that the following conditions are met:
000000r 1               ;      * Redistributions of source code must retain the above copyright
000000r 1               ;        notice, this list of conditions and the following disclaimer.
000000r 1               ;      * Redistributions in binary form must reproduce the above copyright
000000r 1               ;        notice, this list of conditions and the following disclaimer in the
000000r 1               ;        documentation and/or other materials provided with the distribution.
000000r 1               ;      * Neither the name of the author(s) nor the
000000r 1               ;        names of its contributors may be used to endorse or promote products
000000r 1               ;        derived from this software without specific prior written permission.
000000r 1               ;      * Commercial use prohibited without permission of the author(s).
000000r 1               ;
000000r 1               ;  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
000000r 1               ;  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
000000r 1               ;  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
000000r 1               ;  DISCLAIMED. IN NO EVENT SHALL THE AUTHOR(S) BE LIABLE FOR ANY
000000r 1               ;  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
000000r 1               ;  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
000000r 1               ;  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
000000r 1               ;  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
000000r 1               ;  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
000000r 1               ;  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
000000r 1               ;
000000r 1               
000000r 1               ;===============================================
000000r 1               ; BUILD WITH
000000r 1               ; cl65 -o decompressor.prg -t c64 -C c64-asm.cfg -l decompressor.asm  decompressor.s
000000r 1               ;===============================================
000000r 1               
000000r 1               ;screen addresses (you may change sptr+1/sptr+2 directly for other screen locations)
000000r 1               screen=$0400
000000r 1               colour=$D800
000000r 1               
000000r 1               ;zeropage pointer
000000r 1               inv = $fb
000000r 1               col = $fc
000000r 1               p1 = $fd
000000r 1               p2 = $fe
000000r 1               
000000r 1               ;===============================================
000000r 1               ;BASIC start header
000000r 1               
000000r 1               .org $0801
000801  1               
000801  1  0B 08 20 03  .byte $0B, $08, $20, $03, $9E, $32, $30, $36, $31, $00, $00, $00   ; SYS 2061
000805  1  9E 32 30 36  
000809  1  31 00 00 00  
00080D  1               
00080D  1               ;===============================================
00080D  1               ;ASM start
00080D  1               
00080D  1               ;-----------------------------------------------
00080D  1               _decoder:
00080D  1  A9 00          lda #$00
00080F  1  8D 20 D0       sta $D020
000812  1  A9 00          lda #$00
000814  1  8D 21 D0       sta $D021
000817  1  A9 00          lda #$00
000819  1  85 FB          sta inv
00081B  1  85 FC          sta col
00081D  1               loop:
00081D  1  AD 51 09       lda _example
000820  1  EE 1E 08       inc loop+1
000823  1  D0 03          bne n0
000825  1  EE 1F 08       inc loop+2
000828  1               n0:
000828  1  C9 90          cmp #$90  ; black
00082A  1  D0 07          bne n1
00082C  1  A9 00          lda #0
00082E  1  85 FC          sta col
000830  1  4C 1D 08       jmp loop
000833  1               n1:
000833  1  C9 05          cmp #$05  ; white
000835  1  D0 07          bne n2
000837  1  A9 01          lda #1
000839  1  85 FC          sta col
00083B  1  4C 1D 08       jmp loop
00083E  1               n2:
00083E  1  C9 1C          cmp #$1C  ; red
000840  1  D0 07          bne n3
000842  1  A9 02          lda #2
000844  1  85 FC          sta col
000846  1  4C 1D 08       jmp loop
000849  1               n3:
000849  1  C9 9F          cmp #$9F  ; cyan
00084B  1  D0 07          bne n4
00084D  1  A9 03          lda #3
00084F  1  85 FC          sta col
000851  1  4C 1D 08       jmp loop
000854  1               n4:
000854  1  C9 9C          cmp #$9C  ; pink
000856  1  D0 07          bne n5
000858  1  A9 04          lda #4
00085A  1  85 FC          sta col
00085C  1  4C 1D 08       jmp loop
00085F  1               n5:
00085F  1  C9 1E          cmp #$1E  ; green
000861  1  D0 07          bne n6
000863  1  A9 05          lda #5
000865  1  85 FC          sta col
000867  1  4C 1D 08       jmp loop
00086A  1               n6:
00086A  1  C9 1F          cmp #$1F  ; blue
00086C  1  D0 07          bne n7
00086E  1  A9 06          lda #6
000870  1  85 FC          sta col
000872  1  4C 1D 08       jmp loop
000875  1               n7:
000875  1  C9 9E          cmp #$9E  ; yellow
000877  1  D0 07          bne n8
000879  1  A9 07          lda #7
00087B  1  85 FC          sta col
00087D  1  4C 1D 08       jmp loop
000880  1               n8:
000880  1  C9 81          cmp #$81  ; orange
000882  1  D0 07          bne n9
000884  1  A9 08          lda #8
000886  1  85 FC          sta col
000888  1  4C 1D 08       jmp loop
00088B  1               n9:
00088B  1  C9 95          cmp #$95  ; brown
00088D  1  D0 07          bne n10
00088F  1  A9 09          lda #9
000891  1  85 FC          sta col
000893  1  4C 1D 08       jmp loop
000896  1               n10:
000896  1  C9 96          cmp #$96  ; light red
000898  1  D0 07          bne n11
00089A  1  A9 0A          lda #10
00089C  1  85 FC          sta col
00089E  1  4C 1D 08       jmp loop
0008A1  1               n11:
0008A1  1  C9 97          cmp #$97  ; dark gray
0008A3  1  D0 07          bne n12
0008A5  1  A9 0B          lda #11
0008A7  1  85 FC          sta col
0008A9  1  4C 1D 08       jmp loop
0008AC  1               n12:
0008AC  1  C9 98          cmp #$98  ; medium gray
0008AE  1  D0 07          bne n13
0008B0  1  A9 0C          lda #12
0008B2  1  85 FC          sta col
0008B4  1  4C 1D 08       jmp loop
0008B7  1               n13:
0008B7  1  C9 99          cmp #$99  ; light green
0008B9  1  D0 07          bne n14
0008BB  1  A9 0D          lda #13
0008BD  1  85 FC          sta col
0008BF  1  4C 1D 08       jmp loop
0008C2  1               n14:
0008C2  1  C9 9A          cmp #$9A  ; light blue
0008C4  1  D0 07          bne n15
0008C6  1  A9 0E          lda #14
0008C8  1  85 FC          sta col
0008CA  1  4C 1D 08       jmp loop
0008CD  1               n15:
0008CD  1  C9 9B          cmp #$9B  ; light gray
0008CF  1  D0 07          bne n16
0008D1  1  A9 0F          lda #15
0008D3  1  85 FC          sta col
0008D5  1  4C 1D 08       jmp loop
0008D8  1               n16:
0008D8  1  C9 12          cmp #$12  ; inversion on
0008DA  1  D0 07          bne n17
0008DC  1  A9 80          lda #$80
0008DE  1  85 FB          sta inv
0008E0  1  4C 1D 08       jmp loop
0008E3  1               n17:
0008E3  1  C9 92          cmp #$92  ; inversion on
0008E5  1  D0 07          bne n18
0008E7  1  A9 00          lda #0
0008E9  1  85 FB          sta inv
0008EB  1  4C 1D 08       jmp loop
0008EE  1               n18:
0008EE  1  A8             tay
0008EF  1  29 E0          and #$e0
0008F1  1  C9 20          cmp #$20
0008F3  1  D0 04          bne n19
0008F5  1  98             tya
0008F6  1  4C 26 09       jmp print
0008F9  1               n19:
0008F9  1  C9 40          cmp #$40
0008FB  1  D0 06          bne n20
0008FD  1  98             tya
0008FE  1  29 1F          and #$1f
000900  1  4C 26 09       jmp print
000903  1               n20:
000903  1  C9 60          cmp #$60
000905  1  F0 04          beq n21
000907  1  C9 C0          cmp #$c0
000909  1  D0 08          bne n22
00090B  1               n21:
00090B  1  98             tya
00090C  1  29 1F          and #$1f
00090E  1  09 40          ora #$40
000910  1  4C 26 09       jmp print
000913  1               n22:
000913  1  C9 A0          cmp #$A0
000915  1  F0 04          beq n23
000917  1  C9 E0          cmp #$E0
000919  1  D0 08          bne n24
00091B  1               n23:
00091B  1  98             tya
00091C  1  29 1F          and #$1f
00091E  1  09 60          ora #$60
000920  1  4C 26 09       jmp print
000923  1               n24:
000923  1  4C 1D 08       jmp loop
000926  1               
000926  1               print:
000926  1  29 7F          and #$7f
000928  1  05 FB          ora inv
00092A  1               sptr:
00092A  1  8D 00 04       sta screen
00092D  1  EE 2B 09       inc sptr+1
000930  1  D0 03          bne next1
000932  1  EE 2C 09       inc sptr+2
000935  1               next1:
000935  1  A5 FC          lda col
000937  1               cptr:
000937  1  8D 00 D8       sta colour
00093A  1  EE 38 09       inc cptr+1
00093D  1  D0 0A          bne next2
00093F  1  EE 39 09       inc cptr+2
000942  1  A9 DC          lda #(>colour)+4
000944  1  CD 39 09       cmp cptr+2
000947  1  F0 03          beq exit
000949  1               next2:
000949  1  4C 1D 08       jmp loop
00094C  1               
00094C  1               ;-----------------------------------------------
00094C  1               ; finally, we are done (we wait for a keypress)
00094C  1               exit:
00094C  1  A5 C6          lda $c6
00094E  1  F0 FC          beq exit
000950  1  60             rts
000951  1               
000951  1               ;===============================================
000951  1               ;example picture 1, author LgK
000951  1               ; runs in 92364 cycles  -->  ~100ms
000951  1               _example:
000951  1               ; petscii sequence data
000951  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000955  1  20 20 20 20  
000959  1  20 20 20 20  
000971  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000975  1  20 20 20 20  
000979  1  20 20 20 20  
000991  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000995  1  20 20 20 20  
000999  1  20 20 20 20  
0009B1  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
0009B5  1  20 20 20 20  
0009B9  1  20 20 20 20  
0009D1  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
0009D5  1  20 20 20 20  
0009D9  1  20 20 20 20  
0009F1  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
0009F5  1  20 20 20 20  
0009F9  1  20 20 20 20  
000A11  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $9e, $69, $75, $69, $20, $75, $63, $69, $20
000A15  1  20 20 20 20  
000A19  1  20 20 20 20  
000A31  1  75 63 69 20  .byte $75, $63, $69, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000A35  1  20 20 20 20  
000A39  1  20 20 20 20  
000A51  1  62 6A 7B 20  .byte $62, $6a, $7b, $20, $7d, $20, $20, $20, $7d, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000A55  1  7D 20 20 20  
000A59  1  7D 20 20 20  
000A71  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $62, $20, $7d, $20, $7d, $20, $20, $20, $7d, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000A75  1  20 20 20 20  
000A79  1  62 20 7D 20  
000A91  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $6a, $60, $bd, $20, $6a, $63, $6b, $20, $6a, $63, $6b, $20, $20, $20, $20, $20
000A95  1  20 20 20 20  
000A99  1  20 20 20 20  
000AB1  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000AB5  1  20 20 20 20  
000AB9  1  20 20 20 20  
000AD1  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000AD5  1  20 20 20 20  
000AD9  1  20 20 20 20  
000AF1  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000AF5  1  20 20 20 20  
000AF9  1  20 20 20 20  
000B11  1  20 20 20 20  .byte $20, $20, $20, $20, $69, $75, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000B15  1  69 75 20 20  
000B19  1  20 20 20 20  
000B31  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $62, $7d, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000B35  1  20 20 20 20  
000B39  1  20 20 20 20  
000B51  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $6a, $bd, $20, $49, $20, $4e, $20, $54, $20, $41, $20, $47
000B55  1  20 20 20 20  
000B59  1  20 20 20 20  
000B71  1  20 45 20 20  .byte $20, $45, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $75, $6b, $20
000B75  1  20 20 20 20  
000B79  1  20 20 20 20  
000B91  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000B95  1  20 20 20 20  
000B99  1  20 20 20 20  
000BB1  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $7d, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000BB5  1  20 7D 20 20  
000BB9  1  20 20 20 20  
000BD1  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $6a, $6b, $20, $4f, $20, $4d, $20, $50, $20, $55, $20, $54, $20, $49, $20, $4e, $20, $47, $20
000BD5  1  20 20 20 20  
000BD9  1  20 20 20 20  
000BF1  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $75, $6b, $20, $20, $20, $20, $20, $20, $20, $20
000BF5  1  20 20 20 20  
000BF9  1  20 20 20 20  
000C11  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $7d, $20
000C15  1  20 20 20 20  
000C19  1  20 20 20 20  
000C31  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000C35  1  20 20 20 20  
000C39  1  20 20 20 20  
000C51  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $6a, $6b, $20, $41, $20, $52, $20, $49, $20, $4e, $20, $54, $20, $48, $20, $49, $20, $41, $20, $20, $20, $20, $20, $20, $20, $20
000C55  1  20 20 6A 6B  
000C59  1  20 41 20 52  
000C71  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000C75  1  20 20 20 20  
000C79  1  20 20 20 20  
000C91  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000C95  1  20 20 20 20  
000C99  1  20 20 20 20  
000CB1  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000CB5  1  20 20 20 20  
000CB9  1  20 20 20 20  
000CD1  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000CD5  1  20 20 20 20  
000CD9  1  20 20 20 20  
000CF1  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000CF5  1  20 20 20 20  
000CF9  1  20 20 20 20  
000D11  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20, $20
000D15  1  20 20 20 20  
000D19  1  20 20 20 20  
000D31  1  20 20 20 20  .byte $20, $20, $20, $20, $20, $20, $20, $20, $20
000D35  1  20 20 20 20  
000D39  1  20           
000D3A  1               
000D3A  1               ; see http://6502org.wikidot.com/software-incdec for some coding techniques used
000D3A  1               
